require "import"
import "android.icu.util.Calendar"
import "android.icu.util.ULocale"
import "android.icu.text.SimpleDateFormat"
import "android.os.Build"
import "android.widget.*"
import "com.androlua.LuaDialog"

layout={LinearLayout, orientation="vertical", padding = "16dp",
{TextView, text="Sesuaikan waktu pergantian hari.\nWajib di isi semua.", textSize = "16sp", textColor = "#000000", layout_width = "wrap_content", layout_marginTop = "10dp"},
{TextView, text="Masukkan waktu pergantian Jam.", textSize = "16sp", textColor = "#000000", layout_width = "wrap_content", layout_marginTop = "10dp"},
{EditText, hint=" angka00 sampai 23.", id="edit1", layout_width = "match_parent", layout_height = "wrap_content"},
{TextView, text="Masukkan waktu pergantian menit.", textSize = "16sp", textColor = "#000000", layout_width = "wrap_content", layout_marginTop = "10dp"},
{EditText, hint=" angka00 sampai 59.", id="edit2", layout_width = "match_parent", layout_height = "wrap_content"},
{TextView, text="Sesuaikan tanggal:\nTambahkan tanda minus atau tanda hubung di depan angka untuk mengurangi tanggal.\nMasukkan angka saja untuk menambahkan tanggal. Masukkan angka 0 untuk default.", textSize = "16sp", textColor = "#000000", layout_width = "wrap_content", layout_marginTop = "10dp"  },
    {EditText, hint=" masukkan angka di sini", id="edit3", layout_width = "match_parent", layout_height = "wrap_content"}
}
dlg=LuaDialog()
dlg.setCancelable(false).setTitle("Sesuaikan pergantian waktu dan tanggal hijriyah").setView(loadlayout(layout)).setButton("Ok",function()
if edit1.text==""
print(" tidak ada input yang dimasukkan pada Pergantian jam")        
jam=true
elseif edit1.text >="24"
print("Terlalu banyak angka yang dimasukkan pada Pergantian jam")
jam=true
elseif tonumber(edit1.text)==nil
print("Format salah pada Pergantian jam")
jam=true
else
jam=false
end
if edit2.text==""
print(" tidak ada input yang dimasukkan pada Pergantian menit")        
men=true
elseif edit2.text >="60"
print("Terlalu banyak angka yang dimasukkan pada Pergantian menit")
men=true
elseif tonumber(edit2.text)==nil
print("Format salah pada Pergantian menit")
men=true
else
men=false
end
if edit3.text==""
        print(" tidak ada input yang dimasukkan pada penyesuaian tanggal")        
tang=true
elseif tonumber(edit3.text)==nil
        print("format penulisan salah pada penyesuaian tanggal")        
tang=true
else
tang=false
end
if jam and men and tang then
return true
else
        ariJoe=package.searchpath("main",package.path):match("(.*)main.lua").."/main.lua"
local teks=io.open(ariJoe,"r"):read("*all")
local content=teks:gsub("if currentTime.hour > %d+ or %(currentTime.hour == %d+ and currentTime.min >= %d+%) then",                            "if currentTime.hour > "..edit1.text.." or (currentTime.hour == " ..edit1.text.. " and currentTime.min >= " .. edit2.text .. ") then")
        local hasil = content:gsub("local islamicDate = getIslamicDate%((-?%d+), isNextDay%)","local islamicDate = getIslamicDate("..edit3.text..", isNextDay)")
        io.open(ariJoe, "w"):write(hasil):close()
        if edit3.text:gsub("%d+","7")=="7" then
            this.postSpeak(1100,"Tanggal hijriyah telah ditambah sebanyak: "..edit3.text.." dari default. Pergantian  hari pada: "..edit1.text..":"..edit2.text)
        else
            this.postSpeak(1100,"Tanggal hijriyah telah dikurangi sebanyak: "..edit3.text.." dari default. Pergantian  hari pada: "..edit1.text..":"..edit2.text)
        end
        dlg=nil
end
end).setButton2("Batal",function()
this.postSpeak(1100,"Created by: Ari Joe")
end)
-- tampilkan dialog penyesuaian saat fokus pada kotak edit
if this.isEditView(node) dlg.show()
return true end
-- Fungsi untuk mendapatkan pasaran Jawa berdasarkan hari
function getPasaranJawa(isNextDay)
    local today = os.date("*t")
    local pasaran = {"Legi", "Pahing", "Pon", "Wage", "Kliwon"}
    if isNextDay then
        today = os.time{year=today.year, month=today.month, day=today.day + 1}
    else
today = os.time{year=today.year, month=today.month, day=today.day}
    end
    local referenceDate = os.time({year=2024, month=8, day=22})
    local difference = math.floor((today - referenceDate) / (24 * 60 * 60))
    local pasaranIndex = (difference % 5) + 1
    return pasaran[pasaranIndex]
end

-- Fungsi untuk mendapatkan tanggal Universal (Gregorian) dengan nama hari dan pasaran Jawa
function getUniversalDateWithDayName(isNextDay)
    local gregorianCalendar = Calendar.getInstance(ULocale("ID"))
    
    -- Tambahkan satu hari jika isNextDay adalah true
    if isNextDay then
        gregorianCalendar.add(Calendar.DATE, 1)
    end

    local dayOfWeek = gregorianCalendar.get(Calendar.DAY_OF_WEEK)
local pasaran = getPasaranJawa(isNextDay)
    local gregorianSdf = SimpleDateFormat("EEEE '"..pasaran..". Tanggal: "..os.date("%d").."' MMMM yyyy", ULocale("ID"))
    local formattedGregorianDate = gregorianSdf.format(gregorianCalendar.getTime())

    return formattedGregorianDate
end

-- Fungsi untuk mendapatkan tanggal Islam (Hijriah) dengan penyesuaian hari
function getIslamicDate(adjustDays, isNextDay)
    local islamicCalendar = Calendar.getInstance(ULocale("ID@calendar=islamic"))
    
    -- Tambahkan satu hari jika isNextDay adalah true
    if isNextDay then
        islamicCalendar.add(Calendar.DATE, 1)
    end

    islamicCalendar.add(Calendar.DATE, adjustDays)
    local islamicSdf = SimpleDateFormat("dd MMMM yyyy", ULocale("ID@calendar=islamic"))
    local formattedIslamicDate = islamicSdf.format(islamicCalendar.getTime())

    return formattedIslamicDate
end

-- Mendapatkan waktu saat ini
local currentTime = os.date("*t")
local isNextDay = false

-- Cek jika waktu melewati 17:49 maka hitung untuk hari berikutnya
if currentTime.hour > 17 or (currentTime.hour == 17 and currentTime.min >= 50) then
    isNextDay = true
end

-- Mendapatkan tanggal Gregorian dan Hijriyah sesuai waktu saat ini
local gregorianDateWithDayName = getUniversalDateWithDayName(isNextDay)
local islamicDate = getIslamicDate(-1, isNextDay)

if gregorianDateWithDayName and islamicDate then
    local waktu = os.date("%H:%M.")
    local waktuTambahan = isNextDay and " Malam " or " Hari "
    service.speak(waktu)
local batu =". Tingkat baterai: "..service.getBatteryLevel().."%"
    service.appendSpeak(waktuTambahan..gregorianDateWithDayName..". Insya Allah bertepatan pada tanggal: "..islamicDate.." Hijriah"..batu)
else
    print("Sayang sekali gagal menentukan tanggal.")
end